package server;

import org.eclipse.edt.javart.resources.*;
import org.eclipse.edt.javart.*;
import org.eclipse.edt.javart.services.*;
import org.eclipse.edt.javart.Runtime;
import org.eclipse.edt.javart.json.Json;
import com.ibm.as400.access.AS400;
import common.AuthenticationRecord;
import eglx.lang.AnyException;
import org.eclipse.edt.runtime.java.eglx.lang.EString;
import java.lang.String;
import org.eclipse.edt.runtime.java.eglx.lang.AnyStruct;
@SuppressWarnings("unused")

@javax.xml.bind.annotation.XmlRootElement(name="IBMiService")
public class IBMiService extends ServiceBase {
	private static final long serialVersionUID = 10L;
	
	{
		if(Runtime.getRunUnit().getActiveExecutable() == null)
		Runtime.getRunUnit().setActiveExecutable(this);
		ezeInitialize();
	}
	
	public IBMiService() {
		super();
	}
	public void ezeInitialize() {
	}
	@FunctionSignature(name="IBMiAuthentication", parameters={@FunctionParameter(jsonInfo=@Json(name="system", clazz=EString.class, asOptions={}), kind=FunctionParameterKind.IN), @FunctionParameter(jsonInfo=@Json(name="user", clazz=EString.class, asOptions={}), kind=FunctionParameterKind.IN), @FunctionParameter(jsonInfo=@Json(name="password", clazz=EString.class, asOptions={}), kind=FunctionParameterKind.IN), @FunctionParameter(jsonInfo=@Json(name="eze_return", clazz=AuthenticationRecord.class, asOptions={}), kind=FunctionParameterKind.RETURN)})
	public AuthenticationRecord IBMiAuthentication(String system, String user, String password){
		AS400 as400 = new AS400();
		AuthenticationRecord result = new AuthenticationRecord();
		try {
			as400.setSystemName(system);
			result.authenticationSuccessful = as400.validateSignon(user, password);
		}
		catch ( java.lang.Exception eze$Temp1 ) {
			org.eclipse.edt.javart.util.JavartUtil.checkHandleable( eze$Temp1 );
			AnyException exp;
			if ( eze$Temp1 instanceof AnyException ) {
				exp = (AnyException)eze$Temp1;
			}
			else {
				exp = org.eclipse.edt.javart.util.JavartUtil.makeEglException(eze$Temp1);
			}
			{
				result.authenticationSuccessful = false;
				result.messageID = exp.getMessageID();
				result.message = exp.getMessage();
			}
		}
		AuthenticationRecord eze$Temp2 = null;
		return (org.eclipse.edt.runtime.java.eglx.lang.AnyValue.ezeCopyTo(result, eze$Temp2));
	}
}
